 /*                              PAGE MANIPULATOR
   
   This class implements the Job and Runnable Interface. Job Interface as defined in the 
   "Quartz scheduler" domain is the actual task that needs to be schedules. In this case,
   it is the actual parsing of data from data sources in order to store them in the DB.
 */



package CMS;

// Importing General Usage Java libraries
import java.util.*;
import java.util.regex.*;

// Importing Cyberneko parser related libraries
import org.cyberneko.html.HTMLConfiguration;
import org.cyberneko.html.filters.ElementRemover;
import org.cyberneko.html.parsers.*;

// Importing Apache Xerces related libraries
import org.apache.xerces.xni.parser.XMLDocumentFilter;
import org.apache.xerces.xni.parser.XMLInputSource;
import org.apache.xerces.xni.parser.XMLParserConfiguration;
import org.apache.xerces.parsers.*;

// Importing JAXP & JAVA DOCUMENT related libraries
import java.io.IOException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.FactoryConfigurationError;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;

// Importing JAXEN related libraries
import org.jaxen.dom.DOMXPath;

// Importing DOM related libraries
import org.w3c.dom.*;

// Importing Jena related libraries
import com.hp.hpl.jena.db.*;
import com.hp.hpl.jena.ontology.*;
import com.hp.hpl.jena.rdf.model.*;

// Importing quartz scheduler related libraries
import java.util.Date;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;


public class PageManipulator_Modified implements Job, Runnable
{
	Thread t;
	String tName;
	
   	// Create an instance of JenaComponent
	    //JenaComponent jcObj = new JenaComponent();
	
	//Customizing the Cyberneko Parser
        org.cyberneko.html.filters.Writer writer = 
          new org.cyberneko.html.filters.Writer();    
            
    //setup filter chain
        XMLDocumentFilter[] filters = 
        {
                writer,
        };
      
    // create HTML parser
    org.cyberneko.html.parsers.DOMParser par1 = new org.cyberneko.html.parsers.DOMParser();    
    
    // InitialFullURL - URL string of the initial page for each source
    String initialFullURL = ""; 
    
    // A string variable to keep track of the URL of the page that is dealt at a given time
    private String currentWorkingURL = "";
    
    // A string variable to store the sourceHomeURL
    private String sourceHomeURL = "";
    
    // A boolean variable to indicate whether a source was modified or not
    boolean sourceWasModified = false;
        
    public void PageManipulator_Modified()
    {
    	
    	t = new Thread(this);
        try{
        //par1.setProperty("http://cyberneko.org/html/properties/filters", filters);
        par1.setFeature("http://cyberneko.org/html/features/balance-tags",true);
        }
        catch(Exception e) {
        	System.out.println("Exception in PageManipulator Contructor:" + e);
        }
    }
    
    
	public void run()
	{
	  try
	  {
	  	//this.startThread(this.tName);
	  }
	  catch(Exception e)	
	  {
	
	  }
	}
     
    
    /*
      This function is called when the task(job) corresponding to a data source and 
      scheduled by the Quartz scheduler is triggered. This function initiates a series 
      of actions by calling the initiatePM() function
    */  
     
      
    public void execute(JobExecutionContext context) throws JobExecutionException 
	{
	    try
	    {
	    	this.tName = context.getJobDetail().getName();
	    	
	    	String s1 = context.getJobDetail().getName();
	    	StringTokenizer sTokr = new StringTokenizer(s1,"*");
	    	String vals[] = new String[sTokr.countTokens()];
	    	int index = 0;
	    	while(sTokr.hasMoreTokens())
	    	{
	    		vals[index++] = sTokr.nextToken();
	    	}
	    	this.initiatePM(vals[0],vals[1],vals[2],vals[3],vals[4],vals[5]);
	    }
	    catch(Exception e)
	    {
	    	System.out.println("Exception occured in GatherData");
	    }
	}		 

    /*
      This function initiates the process of page manipulation for a given source.
      Details corresponding to the source are read from the meta data  file and 
      are used to parse the source pages to extract desired content.
      As and when a node elements corresponding to the source becomes available,
      they are handled using specified handlers
     */
    public void initiatePM(String category, String srcHomeURL, String countryName, String countryAbbr, String stateName, String stateAbbr)  
      {
      	
       sourceHomeURL = srcHomeURL;
       currentWorkingURL = srcHomeURL;
       String XPEs[][] = null;

       // Results array returned from loadPages()
       String resultsFromloadPagesArr[][] = null;      
       try
       {
        boolean starter = true;
        MetaDataFileInterface mdFI = new MetaDataFileInterface();
        NodeList nl2 = mdFI.getNodeListForSource(srcHomeURL,category);
        NamedNodeMap nnoMap1 = mdFI.getCategoryAttributes(srcHomeURL,category);
       
        
 		for(int i=0;i<nl2.getLength(); i++)
 		{
 			Node nd4 = nl2.item(i);
 			
 			if(nd4.getNodeName() == "citiesListPage")  // to reach page with list of cities
   	 		  {
 	 		     resultsFromloadPagesArr = handleCitiesListNode(nd4, starter,srcHomeURL,nnoMap1,countryName,countryAbbr,stateName, resultsFromloadPagesArr);		
 	 		     if(starter == true)
 	 		        starter = false;
 	 		  }
 			
 	 		 if(nd4.getNodeName() == "statesListPage")  // to reach page with list of states
 	 		  {
 	 		  	resultsFromloadPagesArr = handleStatesListNode(nd4,starter,srcHomeURL,nnoMap1,countryName,countryAbbr);
 	 		  	if(starter == true)
 	 		  	   starter = false;
 	 		  }
 	 		  
 	 		  if(nd4.getNodeName() == "hotelsListPage") // to get page with list of hotels in a city
 			  {
			   handleHotelsListNode(nd4,starter,srcHomeURL,category,nnoMap1,countryName,countryAbbr,stateName,stateAbbr,resultsFromloadPagesArr);
 			   if(starter == true) 	
 			      starter = false;
 			  }
 		}
 	   }//try
	   catch(Exception e)
	   {
		System.out.println("Exception occured while forming a Document initiatePM1");
	   }
     }// initiatePM fn()
    
    
   /* 
    Set Initial URL data to its complete value 
   */ 
    
    public void setInitialFullURL(String temp)         	
    {
    	initialFullURL = temp;
    }
    
    /*
     Get complete value of the InitialURL
     */
    public String getInitialFullURL()
    {
    	return(initialFullURL);
    }
   
  
    /*
     This function handles the hotelsListPage in the source metadata file. 
     */  
    public void handleHotelsListNode(Node nd4, boolean isFirstNode,String srcHomeURL, String category, NamedNodeMap  nnoMap1, String countryName, String countryAbbr, String stateName, String stateAbbr, String[][] prevResults) throws Exception
    {
     	String[][] tempResults = null;
	  	NamedNodeMap nnoMap2 = nd4.getAttributes(); // Get the xPathExpressions for hotelsListNode
	  	String xps[] = new String[nnoMap2.getLength()]; 
	  	for(int i1=0;i1<nnoMap2.getLength();i1++)
	  	{
	  		xps[i1] = nnoMap2.item(i1).getNodeName() + "-->" +  nnoMap2.item(i1).getNodeValue();
	  	}
		             	 			  	
	  	// Get the list of cities from the citylist.xml file
		String [] cities = null;
		String [] argumentArr = null;
		cities = getCities(countryAbbr,stateAbbr);
			
	  	if(isFirstNode == true) // If this is the intial node for this source
	  	 {
	  	   
	  	   /**                MODIFICATION  A
	  	    *
	  	    *     To gather hotel details for all cities.... 
	  	    *     replace 'for' loop statement below
	  	    *     with the following string....
	  	    *
	  	    *      for(int j =0;j<cities.length;j++)	    
	  	    *
	  	    */
	  	   for(int j =0;j<1;j++)	
	       {
	  	    	initialFullURL = "" + formInitialFullURL(srcHomeURL, nnoMap1, countryName, countryAbbr, stateName, stateAbbr, cities[j]);
	  	    	tempResults = loadPages(initialFullURL,xps,1,argumentArr);
	  	    	for(int mm=0;mm<tempResults.length;mm++)
	  	    	{
	  	    	  handleHotelDetailsNode(initialFullURL, countryAbbr, stateAbbr, cities[j], tempResults[mm][1], tempResults[mm][0],srcHomeURL, category);	
	  	    	}
	  	   }
	  	}
	  	 
	  	else
	  	if(isFirstNode == false)
	  	 {  
	  	       /**                MODIFICATION  B
	  	    *
	  	    *     To gather hotel details for all cities.... 
	  	    *     replace 'for' loop statement below
	  	    *     with the following string....
	  	    *
	  	    *      for(int m =0;m<cities.length;m++)	    
	  	    *
	  	    */
	  	
	  	 	for(int m= 0;m<3;m++)//to iterate thru list of cities
	  	 	//for(int m =0;m<cities.length;m++)
	  	 	{
	  	 		String t1 = "";
	  	 		for(int n=0;n<prevResults.length;n++)
	  	 		{
	  	 			System.out.println("**"  + prevResults[n][1].toLowerCase());
	  	 			System.out.println("**"  + cities[m].toLowerCase());
	  	 			
	  	 			if(prevResults[n][1].toLowerCase().indexOf(cities[m].toLowerCase())!=-1)
	  	 			 {
	  	 			 	t1 = "" + prevResults[n][0];
	  	 			 	String tempURL = "" + setCurrentWorkingURL(t1);
	  	 				tempURL = tempURL.replaceAll(" ","");
	  	 				tempResults = loadPages(tempURL,xps,1, argumentArr);
	  	 				for(int mm=0;mm<tempResults.length;mm++)
	  	    			{
	  	    	  			handleHotelDetailsNode(initialFullURL, countryAbbr, stateAbbr, cities[m], tempResults[mm][1], tempResults[mm][0],srcHomeURL, category);	
	  	    			}
	  	 			 }
	  	 		}
	  	 	}
       }
       
       // Update the metadata file if the value of sourceWasModified is true
	  	   MetaDataFileInterface mdFI = new MetaDataFileInterface();
	  	   CurrentTime ct = new CurrentTime();
		   String strDT = ct.getCurrentDate_Time();
		   strDT = strDT.replaceAll(":","");
		   strDT = strDT.replaceAll(" ","T");
		   strDT = strDT.replaceAll("-","");
		   
	       if(sourceWasModified == true) // update all values: lastVisited
	                                     // lastModified and freqOfVisits
	                                     
	  	    {
	  	   	  mdFI.updateFreqOfVisitsNodeValue(srcHomeURL,2);
	  	   	  mdFI.updateTimeNodeValue(srcHomeURL,"lastVisitedOn",strDT);
	  	   	  mdFI.updateTimeNodeValue(srcHomeURL,"lastModifiedOn",strDT);
	  	    }
	  	   else 
	  	   if(sourceWasModified == false) // update lastVisited and freqOfVisits
	  	    {
	  	      mdFI.updateFreqOfVisitsNodeValue(srcHomeURL,1);	
	  	   	  mdFI.updateTimeNodeValue(srcHomeURL,"lastVisitedOn",strDT);
	  	    }
       	
    }
  
    /*
     This function handles the citiesListNode()
    */ 
  
    public String[][] handleCitiesListNode(Node nd4, boolean isFirstNode,String srcHomeURL, NamedNodeMap  nnoMap1, String countryName, String countryAbbr, String stateName, String[][] prevResults) throws Exception
    {
	     String tempResults[][] = null;		
	  	 NamedNodeMap nnoMap2 = nd4.getAttributes();// Get the xPathExpressions for citiesListNode
	  	 String xps[]  = new String[nnoMap2.getLength()]; // initializing 2nd dim of XPEs array
	  	 for(int i1=0;i1<nnoMap2.getLength();i1++)
	  	 {
	  		xps[i1] = nnoMap2.item(i1).getNodeName() + "-->" +  nnoMap2.item(i1).getNodeValue();
	  	 }
	  	 
	  	 if(isFirstNode == true) // if this is the first node for this source
	  	 {
	  	   String tempURL = "" + formInitialFullURL(srcHomeURL, nnoMap1, countryName, countryAbbr, "", "", "");
	  	   String [] argumentArr = null;
	  	   setInitialFullURL(tempURL);
	  	   tempResults = loadPages(initialFullURL,xps,1,argumentArr);
	  	 }
	  	 else
	  	 {
	  	 	String t1 = "";
	  	 	String [] argumentArr = null;
	  	 	for(int k=0;k<prevResults.length;k++)
	  	 	{
	  	 		if(prevResults[k][1].toLowerCase().indexOf(stateName.toLowerCase()) != -1)
	  	 		 {
	  	 		 	t1 = "" + prevResults[k][0];
	  	 			String tempURL = "" + setCurrentWorkingURL(t1);
			  	 	tempResults = loadPages(tempURL,xps,1,argumentArr);
	  	 		 }
	  	 	}
	  	 } 
	   return(tempResults);
    }
    
    
    /*
     This handles the statesListPage node in the source metadata file
    */
    public String[][] handleStatesListNode(Node nd4, boolean isFirstNode, String srcHomeURL, NamedNodeMap  nnoMap1, String countryName, String countryAbbr) throws Exception
    {
        String tempResults[][] = null;
        String argumentArr[] = null;
	  	NamedNodeMap nnoMap2 = nd4.getAttributes();// Get the xPathExpressions for statesListNode
	  	String xps[] = new String[nnoMap2.getLength()]; 
	  	for(int i1=0;i1<nnoMap2.getLength();i1++)
	  	{
	  		xps[i1] = nnoMap2.item(i1).getNodeName() + "-->" +  nnoMap2.item(i1).getNodeValue();
	  	}
	  	
	  	if(isFirstNode == true) // if this is the first node for this source
	  	{
	  	   String tempURL =  "" + formInitialFullURL(srcHomeURL, nnoMap1, countryName, countryAbbr, "", "", "");
	  	   tempResults = loadPages(tempURL,xps,1,argumentArr);
	  	}	
	  	return(tempResults);
    }
    
    
    /*
     This handles the hotelDetailsPage node of source metadat file
     */
    
    
    public void handleHotelDetailsNode(String initialFullURL, String countryAbbr, String stateAbbr, String cityName, String hotelName, String hotelPartURL, String srcHomeURL, String category) throws Exception
    {
       MetaDataFileInterface mdFI = new MetaDataFileInterface();
       NodeList nl1 = mdFI.getNodeListForSource(srcHomeURL,category);
       
       String tempResults[][] = null;
       for(int i=0;i<nl1.getLength(); i++)
         {
           Node nd4 = nl1.item(i);
           if(nd4.getNodeName() == "hotelDetailsPage")
 			  {
 			  	NamedNodeMap nnoMap2 = nd4.getAttributes();// Get the xPathExpressions for page2
 			  	String XPEs[] = new String[nnoMap2.getLength()]; 
 			  	for(int i1=0;i1<nnoMap2.getLength();i1++)
 			  	{
 			  		XPEs[i1] = nnoMap2.item(i1).getNodeName() + "-->" +  nnoMap2.item(i1).getNodeValue();
 			  	}

		        String tempURL = setCurrentWorkingURL(hotelPartURL);
		        
		        // Visit the exact URL page of the hotel description          
		            // Use countryAbbr, hotelName ... to form a unique 
		            //Id for the hotel instance in the DB
		        String tempStr[] = { category, srcHomeURL, countryAbbr, stateAbbr, cityName, hotelName};
		        tempResults = loadPages(tempURL,XPEs,2,tempStr);	
 			   } 
	    }
	 }   
    
    
   /*
    This function  returns an URL that acts the basic URL by which the source is contacted first
    Only from the pages all other links (direct and indirect) to hotel details pages
    are gathered
    */
    
   public String formInitialFullURL(String srcHomeURL, NamedNodeMap nmap,String cnName, String cnAbbr, String stName, String stAbbr, String ciName )
    {
           	Node ndSpace = nmap.getNamedItem("spaceFiller"); // part of URL
           	String spaceFiller = ndSpace.getNodeValue(); // part of initial page to be loaded for each source
           	
           	cnName = cnName.replaceAll(" ",spaceFiller);
           	stName = stName.replaceAll(" ",spaceFiller);
           	
           	Node ndFormat = nmap.getNamedItem("format"); // part of URL
           	String format = ndFormat.getNodeValue(); // part of initial page to be loaded for each source
           	
           	if(format.compareTo("allSmall") == 0)
           	 {
           	 	cnName = cnName.toLowerCase();
           	 	stName = stName.toLowerCase();
           	 	stAbbr = stAbbr.toLowerCase();
           	 	ciName = ciName.toLowerCase();
           	 }
           	
           	Node ndPartURL = nmap.getNamedItem("initialPartURL"); // part of URL
           	String initialPartURL = ndPartURL.getNodeValue(); // part of initial page to be loaded for each source


      	   	 initialPartURL = initialPartURL.replaceAll("CountryName",cnName);
      	   	 initialPartURL = initialPartURL.replaceAll("CountryAbbreviation",cnAbbr);

      	   	 initialPartURL = initialPartURL.replaceAll("StateName",stName);
      	   	 initialPartURL = initialPartURL.replaceAll("StateAbbreviation",stAbbr);
      	   	 initialPartURL = initialPartURL.replaceAll("CityName",ciName);
      	   	 
           currentWorkingURL = "" + sourceHomeURL + initialPartURL;
           return(currentWorkingURL);
     }
    

    /*
      This function is used to get list of cities from the cityList.xml file
      cityList.xml is a flat file that has sample cities listed for few states in USA.
      PageManipulator_Modified class gathers details of all hotels for all cities 
      listed in the xml file from the chosen source.
     */
      
    public String[] getCities(String countryID, String stateID)
    {
      String cities[] = null;
      try
      {
      String xmlFile = "citylist.xml"; 	
      Document doc = formDocument(xmlFile);
      Element srcElt = doc.getElementById(countryID); // Get the country element
      NodeList nl1 = srcElt.getElementsByTagName("State");
      
      for(int i=0;i<nl1.getLength();i++)
      {
      	  NamedNodeMap nnoMap1 = nl1.item(i).getAttributes();
          Node nd1 = nnoMap1.getNamedItem("id"); // Node from the Attribute nodes list
          
          if(nd1.getNodeValue().compareTo(stateID) == 0)
           {
           	  NodeList nl2 = nl1.item(i).getChildNodes();
           	  int cityCount = 0;
           	  for(int j=0;j<nl2.getLength(); j++)
           	  {
           	  	if(nl2.item(j).getNodeName() == "City")
           	  	  cityCount++;
           	  }

           	  cities = new String[cityCount]; int c = 0;
           	  
           	  for(int j=0;j<nl2.getLength(); j++)
           	  {
          	  	if(nl2.item(j).getNodeName() == "City")
          	  	 {
          	  	 	NodeList nl3 = nl2.item(j).getChildNodes();
          	  	  	String t1 = nl3.item(0).getNodeValue() ;
          	  	  	t1 = t1.toLowerCase();
          	  	 	cities[c++] = t1.trim();
          	  	 	
          	  	 }
           	  }
           	  
           }
      }
     }
     catch(Exception e)
      {
      	System.out.println("Exception occured in getCities of PageManipulator" + e);
      }
      return(cities);
    }
    
    

    /*
      Function to form an DOCUMENT object given an XML source file
     */ 
    public Document formDocument(String xmlSourceFile) throws Exception
    {
	    DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
	    DocumentBuilder builder = factory.newDocumentBuilder();
	    Document document = builder.parse(xmlSourceFile);
	    return(document);
    }
   
  public String setCurrentWorkingURL(String relativeURL)
   {
       System.out.println("Current Working URL ==>" + currentWorkingURL);
       System.out.println("Relative URL ==>" + relativeURL);
       
       relativeURL = relativeURL.replaceAll("\\s","");
       
       String temp = relativeURL;
       String tempWorkingURL = "";
       String tempTopURL = "";
       
       temp = temp.replaceAll("href","");
       temp = temp.replaceAll("=","");
       temp = temp.replaceAll("\"","");
       //temp = temp.replaceAll("\\s","");
              
       // get the toplevel URL part from the currentWorkingURL
       String REGEX = "http://.*\\." + ".*" + "\\." + "[^htl]{3}+";
       String INPUT = currentWorkingURL;
       Pattern pattern = Pattern.compile(REGEX);
       Matcher matcher = pattern.matcher(INPUT);
       while(matcher.find()) 
       {
            tempTopURL = matcher.group();
        	int i = tempTopURL.lastIndexOf("/");
        	if(i > 6)
        	   tempTopURL = tempTopURL.substring(0,i);

       }
       
       // Find part of reltiveURL to be concatenated to form absoluteURL
       String temp2 = temp;
              
       // Count number of preceding dots in relativeURL
       String temper  = "";
       if(temp.indexOf("/") != -1)
           temper = temp.substring(0,temp.indexOf("/"));
       int dotCount = 0; int sPos = -1;
       while(true)
       {
          sPos = temper.indexOf(".",sPos);
          if(sPos == -1)
            break;
          else
           {
           	dotCount++;
            sPos++;
           }
       }
        
       if(relativeURL.toLowerCase().indexOf("http") != -1)
	       {
	       	tempWorkingURL = relativeURL;
	       }
       else
       if(dotCount > 0)       
	       {
	       temp2 = temp2.substring(temp2.indexOf("/")+1,temp2.length());	
	       // Use number of dots in relativeURL to find a part for absoluteURL from
	         // categoryHomeURL
	       int p1 = -1;
	       for(int i =0;i<dotCount+2;i++)
	       {
	       	p1 =  currentWorkingURL.indexOf("/",p1);
	       	p1++;
	       }
	       // Concatenate parts from relativeURL and categoryHomeURL to form
	         // absoluteURL
	       String s1 = currentWorkingURL.substring(0,p1);
	       s1 = s1 + temp2;
	       tempWorkingURL =  s1;
	       }
       else
	       if(relativeURL.indexOf("/") == 0)
	       {
	         tempWorkingURL =  tempTopURL + relativeURL;
	       }
        
       else
       //if(relativeURL.indexOf("/") == -1)
         {
         	tempWorkingURL =  currentWorkingURL.substring(0,currentWorkingURL.lastIndexOf("/")+1) + relativeURL;
         }
         
       currentWorkingURL =  "" + tempWorkingURL;
       return(tempWorkingURL);
   } 
   
    /*
     This function is used to Load a given URL using Cyberneko HTML parse 
     and extract data from the loaded pages using JAXEN
    */ 
    public String[][] loadPages(String url, String[] xps,int page1page2, String[] tempValues) throws Exception 
    {
         
         System.out.println("URL of the page thatz gonna be loaded is:  " + url);
         
         String systemId = url;
         XMLInputSource source = new XMLInputSource(null, systemId, null);
         par1.parse(source);
         Document doc = par1.getDocument();  
         String tempXps[] = new String[xps.length];
         for(int i=0;i<tempXps.length;i++)
         {
         	 tempXps[i] = xps[i];
         }
                  
         try
          {
              // Find the total number of xpath expressions
              // Declare variables required for parsing
              int noXps = xps.length;
              DOMXPath dxp[] = new DOMXPath[noXps]; 
              List results[] = new List[noXps];
              ListIterator l_iter[] = new ListIterator[noXps];
          				
			  // Initialize and Populate variables required during parsing	                          
			  int index = 0;
			  
              for(int i=0;i<noXps;i++)
              {
               	if(xps[i].indexOf("-->") != -1)
           	    index = xps[i].indexOf("-->")+3;
              	xps[i] = xps[i].substring(index, xps[i].length());
              	dxp[i] = new DOMXPath(xps[i]);      
              	results[i] = (List) dxp[i].evaluate(doc);
               	l_iter[i] = results[i].listIterator();
     		  }
               
              String returnValues[][] = new String[results[0].size()][noXps];
                            
              if(page1page2 == 1) {
              	for(int i =0; i<results[0].size(); i++) {
              		for(int j = 0;j<noXps; j++) {
	              		  returnValues[i][j] = "" + l_iter[j].next();
	               		}}
	            
	              for(int i=0;i<results[0].size();i++) {
	               	for(int j=0;j<noXps;j++) {
	              	  	if(returnValues[i][j].indexOf("href=") !=-1) {
	              	  	 	returnValues[i][j] = returnValues[i][j].replaceAll("href=","");
	              	  	 	returnValues[i][j] = returnValues[i][j].replaceAll("\"","");
	              	  	 	//returnValues[i][j] = returnValues[i][j].replaceAll("\\s","");
	              	  	 	//returnValues[i][j] = returnValues[i][j].toLowerCase().replaceAll("#text:","");
	              	  	 	//System.out.print("\t" + returnValues[i][j]);
	              	  	 }
	              	  	else  
	              	  	  System.out.print("\t" + returnValues[i][j]);
	              	  	  //System.out.print("");
	              	  }
	              }
              }
              else
              if(page1page2 == 2) // Implies that results of parsing has to be stored in the DB
              {
               	 String clN = "", NS = "", insID = "", resN = "", propName = "";
               	 if (tempValues[0].compareTo("hotels") == 0)
               	  {
               	  	clN = "Hotel";
               	  	NS = "http://www.agentlab.com/schemas/hotel.rdf#";
               	  }
               	  insID = tempValues[1]+"_"+tempValues[2]+"_"+tempValues[3]+"_"+tempValues[4];
               	  resN = tempValues[5].replaceAll("text","");
               	  resN = resN.replaceAll(" ","");
               	  insID = insID + "_"+ resN;
               	 
               	  PersistentOntology po = new PersistentOntology();
              	  Individual inst1 = po.createClassInstance(NS, clN,insID);
               	 
               	 // We now have the properties to be assigned for each instance created above
               	 for(int i=0;i<noXps;i++) 
               	  {
               	  	String tempStr = "";               	  
               	  	while(l_iter[i].hasNext() == true)
               	  	 {
               	  	 	tempStr = tempStr + "" + l_iter[i].next();
               	  	 }
               	  	 
               	  	 if(tempXps[i].toLowerCase().indexOf("address") != -1)
               	  	 {
               	  	 	propName = "address";
               	  	 	NS = "http://www.agentlab.com/schemas/location.rdf#";
               	  	 }
               	  	 else
               	  	 if(tempXps[i].toLowerCase().indexOf("amenities") != -1)
               	  	 {
               	  	 	propName = "hotelAmenity";
               	  	 	NS = "http://www.agentlab.com/schemas/hotel.rdf#";
               	  	 }
               	  	 
               	  	 //System.out.println("values are :--->  " + tempStr);
               	  	 boolean result = po.addPropertyValuesToInstance(inst1,NS,propName,tempStr);   
               	  	 if(result == true)
               	  	    sourceWasModified = true;
               	  }
              }
              return(returnValues);
           }
          catch (Exception e)
           {
            	System.out.println("Jaxen Exception:"  + e);
            	String dummy[][] = new String[1][1];
            	return(dummy);
           }
   } // Fn() loadPages
 } // CLASS PageManipulator